Index: mythcontrols/keybindings.h
===================================================================
--- mythcontrols/keybindings.h	(revision 10604)
+++ mythcontrols/keybindings.h	(working copy)
@@ -30,99 +30,132 @@
 #include "actionid.h"
 #include "actionset.h"
 
+
 /**
  * @class KeyBindings.
  * @brief Information about the current keybindings.
  *
  * This class can retrieve, set, and modify the keybindings used by
  * mythtv.  It is a layer between the user interface, and the
- * keybindings themeslfs.
+ * keybindings themeslfs.  All of the logic behind conflicts, etc is
+ * kept here, as well as the database routines.
  */
 class KeyBindings {
 
 public:
 
-    /**
-     * @brief Levels of conflict 
-     * @li None: Does not conflict
-     * @li Potential: May conflict.
-     * @li Fatal: Frontend will become inoperable.
-     */
+    /** Levels of conflict */
     enum ConflictLevels { Warning, Error};
 
     /**
-     * @brief Create a new KeyBindings instance.
+     * Create a new KeyBindings instance.
+     *
      * @param hostname The host for which to create the key bindings.
      */
     KeyBindings(const QString & hostname);
 
     /**
-     * @brief Get the hostname these keybindings are from.
-     * @return The hostname these keybindings are from.
+     * Determine the context belonging to the key and action
+     *
+     * @param action The action.
+     * @param anum The action number (in the list of all of a keys actions).
+     *
+     * @warning This method falls apart if the actionset class doesn't
+     * sort it the actions lists in the _kemap variable.
      */
-    inline const QString & getHostname() const { return this->_hostname; }
+    QString GetContext(const QString & key, const QString & action,
+                       size_t anum) const;
 
     /**
-     * @brief Get a list of the context names.
+     * Get a list of the context names.
+     *
      * @return A list of the context names.
-     * @note The returned list is a copy and can be modified without
-     * side-effects.
      */
-    inline QStringList * getContexts() const
+    inline QStringList * GetContexts() const
     {
-        return actionset.contextStrings();
+        return m_ActionSet.ContextStrings();
     }
 
     /**
-     * @brief Get a list of the actions in a context.
+     * Get the contexts in which a key is bound.
+     *
+     * @param key The key.
+     * @return A string list containing the context names.
+     */
+    inline QStringList * GetContexts(const QString & key) const
+    {
+        return m_ActionSet.GetKeyContexts(key);
+    }
+
+    /**
+     * Get a list of the actions in a context.
+     *
      * @param context The name of the context.
      * @return A list of action (names) for the target context.
-     * @note Store this instead of calling repeatedly.  Every time you
-     * do, ActionSet has to iterate over all contexts and actions.
      */
-    inline QStringList * getActions(const QString & context) const
+    inline QStringList * GetActions(const QString & context) const
     {
-        return actionset.actionStrings(context);
+        return m_ActionSet.ActionStrings(context);
     }
 
     /**
-     * @brief Get a list of the actions in a context.
+     * Get the action bound to a key in a particular context.
+     *
+     * @param key The key.
+     * @param context The context.
+     * @return The action.
+     */
+    QString GetAction(const QString & key, const QString & context) const;
+
+    /**
+     * Get all bound keys.
+     *
+     * @return A string list of the bound keys.
+     */
+    inline QStringList * GetAllKeys() const
+    {
+        return m_ActionSet.GetAllKeys();
+    }
+
+    /**
+     * Get a list of the actions in a context.
+     *
      * @param context The name of the context.
      * @return A list of action (names) for the target context.
      * @note Store this instead of calling repeatedly.  Every time you
      * do, ActionSet has to iterate over all contexts and actions.
      */
-    inline void getKeyActions(const QString &key, ActionList &list) const
-    {
-        list = actionset.getActions(key);
-    }
+    QStringList * GetKeyActions(const QString &key) const;
 
     /**
-     * @brief Get an action's keys.
+     * Get an action's keys.
+     *
      * @param context_name The name of the context.
      * @param action_name The name of the action.
      * @return The keys bound to the specified context's action
      */
-    inline QStringList getActionKeys(const QString & context_name,
+    inline QStringList GetActionKeys(const QString & context_name,
                                      const QString & action_name) const
     {
-        return actionset.getKeys(ActionID(context_name, action_name));
+        return m_ActionSet.GetKeys(ActionID(context_name, action_name));
     }
 
     /**
-     * @brief Get an action's description.
+     * Get an action's description.
+     *
      * @param context_name The name of the context.
      * @param action_name The name of the action.
      * @return The description of the specified context's action
      */
-    inline QString getActionDescription(const QString & context_name,
+    inline QString GetActionDescription(const QString & context_name,
                                         const QString & action_name) const
     {
-        return actionset.getDescription(ActionID(context_name, action_name));
+        return m_ActionSet.GetDescription(ActionID(context_name, action_name));
     }
 
     /**
-     * @brief Add a key to an action.
+     * Add a key to an action.
+     *
      * @param context_name The name of the context.
      * @param action_name The name of the action.
      * @param key The key to add.
@@ -131,15 +164,16 @@
      * This does not take effect until the commitChanges function is
      * called.
      */
-    inline void addActionKey(const QString & context_name,
+    inline void AddActionKey(const QString & context_name,
                              const QString & action_name,
                              const QString & key)
     {
-        this->actionset.add(ActionID(context_name, action_name), key);
+        this->m_ActionSet.Add(ActionID(context_name, action_name), key);
     }
 
     /**
-     * @brief Determine if adding a key would cause a conflict.
+     * Determine if adding a key would cause a conflict.
+     *
      * @param context_name The name of the context.
      * @param key The key to add.
      * @param level The level of conflict.  Check this if the return
@@ -157,11 +191,12 @@
      * errors should be prevented no matter what.  If they dont like it,
      * they can learn SQL.
      */
-    ActionID * conflicts(const QString & context_name,
+    ActionID * Conflicts(const QString & context_name,
                          const QString & key, int &level) const;
 
     /**
-     * @brief Replace a key in an action.
+     * Replace a key in an action.
+     *
      * @param context_name The name of the context.
      * @param action_name The name of the action.
      * @param newkey The key to add.
@@ -171,122 +206,96 @@
      * This does not take effect until the commitChanges function is
      * called.
      */
-    inline void replaceActionKey(const QString & context_name,
+    inline void ReplaceActionKey(const QString & context_name,
                                  const QString & action_name,
                                  const QString & newkey,
                                  const QString & oldkey)
     {
-        this->actionset.replace(ActionID(context_name, action_name),
+        this->m_ActionSet.Replace(ActionID(context_name, action_name),
                                 newkey, oldkey);
     }
 
     /**
-     * @brief Unbind a key from an action.
+     * Unbind a key from an action.
+     *
      * @param context_name The name of the context.
      * @param action_name The name of the action.
      * @param key The key to remove.
      * @return true if the key was removed, or false if it was not.
      *
-     * Unless the action is manditory there is only one key in the
+     * Unless the action is mandatory and there is only one key in the
      * action, this method should return true.
      */
-    bool removeActionKey(const QString & context_name,
+    bool RemoveActionKey(const QString & context_name,
                          const QString & action_name,
                          const QString & key);
 
-    /**
-     * @brief Set the manditory bindings to their defaults.
-     */
-    void defaultManditoryBindings(void);
+    /** Set the mandatory bindings to their defaults. */
+    void DefaultMandatoryBindings(void);
 
     /**
-     * @brief Determine if there are changes to the keybindings.
+     * Determine if there are changes to the keybindings.
+     *
      * @return True if keys have been changed, otherwise, false.
      */
-    inline bool hasChanges(void) const { return actionset.hasModified(); }
+    inline bool HasChanges(void) const
+    {
+        return m_ActionSet.HasModified();
+    }
 
     /**
-     * @brief Commit all changes made to the keybindings.
-     *
-     * This method will write the changes to the database, unbind myth's
-     * current bindings for those actions that changed, and setup the
-     * new bindings.
+     * Commit the changes made to the keybindings into the database.
      */
-    void commitChanges(void);
+    void CommitChanges(void);
 
     /**
-     * @brief Get a list of the manditory key bindings.
-     * @return A list of the manditory bindings.
+     * Get a list of the mandatory key bindings.
+     *
+     * @return A list of the mandatory bindings.
      */
-    inline const ActionList& getManditoryBindings(void) const
+    inline const ActionList& getMandatoryBindings(void) const
     {
-        return this->_manditory_bindings;
+        return this->m_MandatoryBindings;
     }
 
     /**
-     * @brief Determine if all manditory bindings are satisfied.
-     * @return true if all manditory bindings are satisfied, otherwise, false.
+     * Determine if all mandatory bindings are satisfied.
+     *
+     * @return true if all mandatory bindings are satisfied,
+     * otherwise, false.
      */
-    bool hasManditoryBindings(void) const;
+    bool HasMandatoryBindings(void) const;
 
 protected:
 
-    /**
-     * @brief Get a reference to the hostname.
-     * @return A reference to the hostname.
-     */
-    inline QString & hostname() { return this->_hostname; }
+    /** Commit a jumppoint to the database. */
+    void CommitJumppoint(const ActionID &id);
 
-    /**
-     * @brief Commit a jumppoint to the database.
-     *
-     * This (currently) does not reload the jumppoint.
-     */
-    void commitJumppoint(const ActionID &id);
+    /** Commit an action to the database, and reload its keybindings. */
+    void CommitAction(const ActionID & id);
 
-    /**
-     * @brief Commit an action to the database, and reload its keybindings.
-     */
-    void commitAction(const ActionID & id);
+    /** Load the jumppoints from the database. */
+    void RetrieveJumppoints(void);
 
-    /**
-     * @brief Load the jumppoints from the database.
-     *
-     * This method will load the keybindings for jump points.
-     */
-    void retrieveJumppoints(void);
+    /** Load the keybindings from the database. */
+    void RetrieveContexts(void);
 
-    /**
-     * @brief Load the keybindings from the database.
-     *
-     * This will load the keybindings which apply to the hostname
-     * specified to the constructor.
-     */
-    void retrieveContexts(void);
+    /** Load the mandatory bindings. */
+    void LoadMandatoryBindings(void);
 
-    /**
-     * @brief Load the manditory bindings.
-     */
-    void loadManditoryBindings(void);
+private:
 
-    /**
-     * @brief Get a reference to the list of the manditory key bindings.
-     * @return A reference to the list of the manditory bindings.
-     */
-    inline ActionList & manditoryBindings(void) { return _manditory_bindings; }
+    /** The hostname */
+    QString m_HostName;
 
-    /**
-     * @brief Get the default keys.
-     * @return A list of the default keys.
-     */
-    inline QStringList & defaultKeys() { return _default_keys; }
+    /** List of mandatory bindings */
+    ActionList m_MandatoryBindings;
 
-private:
+    /** List of the default key bindings */
+    QStringList m_DefaultKeys;
 
-    QString _hostname;
-    ActionList _manditory_bindings;
-    QStringList _default_keys;
-    ActionSet actionset;
+    /** The action set */
+    ActionSet m_ActionSet;
 };
 
 #endif /* KEYBINDINGS_H */
Index: mythcontrols/action.cpp
===================================================================
--- mythcontrols/action.cpp	(revision 10604)
+++ mythcontrols/action.cpp	(working copy)
@@ -34,18 +34,19 @@
 
 Action::Action(const QString & description, const QString & keys)
 {
-    this->description() = description;
-    this->keys() = QStringList::split(", ", QString(QKeySequence(keys)));
+    m_Description = description;
+    m_Keys = QStringList::split(", ", QString(QKeySequence(keys)));
 }
 
 
 
-bool Action::hasKey(const QString & key) const
+bool Action::HasKey(const QString & key) const
 {
     /* check the keys */
-    for (size_t i = 0; i < getKeys().count(); i++)
+    for (size_t i = 0; i < GetKeys().count(); i++)
     {
-        if (getKeys()[i] == key) return true;
+        if (GetKeys()[i] == key)
+            return true;
     }
 
     /* the key was not found, so return false */
@@ -54,33 +55,33 @@
 
 
 
-bool Action::addKey(const QString & key)
+bool Action::AddKey(const QString & key)
 {
 
     /* dont add empty keys and dont add too many, or duplicates  */
     if ((key.length() == 0) ||
-        (getKeys().size() >= MAX_KEYS) ||
-        (getKeys().contains(key)))
+        (GetKeys().size() >= MAX_KEYS) ||
+        (GetKeys().contains(key)))
         return false;
 
     /* add the key */
-    this->keys().push_back(key);
+    m_Keys.push_back(key);
     return true;
 }
 
 
 
 /* comments in header */
-bool Action::replaceKey(const QString & newkey, const QString &oldkey)
+bool Action::ReplaceKey(const QString & newkey, const QString &oldkey)
 {
     /* make sure that the key list doesn't already have the new key */
-    if (getKeys().contains(newkey) == 0)
+    if (GetKeys().contains(newkey) == 0)
     {
-        for (size_t i = 0; i < getKeys().size(); i++)
+        for (size_t i = 0; i < GetKeys().size(); i++)
         {
-            if (getKeys()[i] == oldkey)
+            if (GetKeys()[i] == oldkey)
             {
-                keys()[i] = newkey;
+                m_Keys[i] = newkey;
                 return true;
             }
         }
